'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require('react-bootstrap');

var _Actions = require('../../Actions');

var _Icon = require('../../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Title = require('./Title.scss');

var _Title2 = _interopRequireDefault(_Title);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Title(_ref) {
	var cellData = _ref.cellData,
	    columnData = _ref.columnData,
	    dataKey = _ref.dataKey,
	    rowData = _ref.rowData,
	    rowIndex = _ref.rowIndex;
	var id = columnData.id,
	    _onClick = columnData.onClick,
	    iconKey = columnData.iconKey,
	    actionsKey = columnData.actionsKey;


	return _react2.default.createElement(
		'div',
		{
			id: id && id + '-' + rowIndex + '-title',
			className: _Title2.default['tc-list-title']
		},
		iconKey && rowData[iconKey] && _react2.default.createElement(_Icon2.default, { name: rowData[iconKey], className: _Title2.default.icon }),
		_react2.default.createElement(
			_reactBootstrap.Button,
			{
				id: 'tc-list-item-' + rowIndex + '-title',
				className: _Title2.default['main-button'],
				onClick: function onClick(event) {
					return _onClick(event, rowData);
				},
				role: 'link',
				bsStyle: 'link'
			},
			cellData
		),
		actionsKey && rowData[actionsKey] && _react2.default.createElement(_Actions.Actions, {
			actions: rowData[actionsKey],
			hideLabel: true,
			link: true
		})
	);
}

Title.propTypes = {
	cellData: _react.PropTypes.string,
	columnData: _react.PropTypes.shape({
		id: _react.PropTypes.string,
		onClick: _react.PropTypes.func.isRequired,
		iconKey: _react.PropTypes.func,
		actionsKey: _react.PropTypes.func
	}),
	dataKey: _react.PropTypes.string,
	rowData: _react.PropTypes.object, // eslint-disable-line
	rowIndex: _react.PropTypes.number
};

exports.default = Title;