'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactVirtualized = require('react-virtualized');

var _List = require('./List.scss');

var _List2 = _interopRequireDefault(_List);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function noRowsRenderer() {
	return _react2.default.createElement(
		'div',
		{ className: 'tc-list-no-rows' },
		'No rows'
	);
}

function List(_ref) {
	var children = _ref.children,
	    collection = _ref.collection,
	    height = _ref.height,
	    rowHeight = _ref.rowHeight,
	    rowRenderer = _ref.rowRenderer,
	    width = _ref.width;

	return _react2.default.createElement(_reactVirtualized.List, {
		children: children,
		className: _List2.default['tc-list-list'],
		collection: collection,
		height: height,
		overscanRowCount: 10,
		noRowsRenderer: noRowsRenderer,
		rowCount: collection.length,
		rowHeight: rowHeight,
		rowRenderer: rowRenderer,
		width: width
	});
}
List.displayName = 'VirtualizedList(List)';
List.propTypes = _extends({}, _reactVirtualized.List.propTypes, {
	collection: _react.PropTypes.arrayOf(_react.PropTypes.object),
	rowHeight: _react.PropTypes.number,
	rowRenderer: _react.PropTypes.element
});
List.defaultProps = {
	rowHeight: 125
};

exports.default = List;