'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactVirtualized = require('react-virtualized');

var _Table = require('./Table.scss');

var _Table2 = _interopRequireDefault(_Table);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create new Columns from children with component fixed classnames
 */
function toColumns(children) {
	return _react2.default.Children.toArray(children).map(function (field) {
		var colProps = _extends({}, field.props, {
			headerClassName: (0, _classnames2.default)(field.props.headerClassName, _Table2.default.header),
			className: (0, _classnames2.default)(field.props.className, _Table2.default.cell)
		});
		return _react2.default.createElement(_reactVirtualized.Column, colProps);
	});
}

function Table(props) {
	var children = props.children,
	    collection = props.collection,
	    height = props.height,
	    sort = props.sort,
	    sortBy = props.sortBy,
	    sortDirection = props.sortDirection,
	    width = props.width;

	return _react2.default.createElement(
		_reactVirtualized.Table,
		{
			className: _Table2.default['tc-list-table'],
			gridClassName: _Table2.default.grid,
			headerHeight: 35,
			height: height,
			rowClassName: _Table2.default.row,
			rowCount: collection.length,
			rowGetter: function rowGetter(_ref) {
				var index = _ref.index;
				return collection[index];
			},
			rowHeight: 50,
			sort: sort,
			sortBy: sortBy,
			sortDirection: sortDirection,
			width: width
		},
		toColumns(children)
	);
}
Table.displayName = 'VirtualizedList(Table)';
Table.propTypes = _extends({}, _reactVirtualized.Table.propTypes, {
	children: _react.PropTypes.arrayOf(_react.PropTypes.element),
	collection: _react.PropTypes.arrayOf(_react.PropTypes.object),
	sort: _react.PropTypes.func,
	sortBy: _react.PropTypes.string,
	sortDirection: _react.PropTypes.string
});

exports.default = Table;