'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('./utils');

var _Large = require('./Large.scss');

var _Large2 = _interopRequireDefault(_Large);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Large(_ref) {
	var index = _ref.index,
	    key = _ref.key,
	    parent = _ref.parent,
	    style = _ref.style;

	var _extractTitle = (0, _utils.extractTitle)(parent),
	    titleField = _extractTitle.titleField,
	    otherFields = _extractTitle.otherFields;

	var titleCell = (0, _utils.renderCell)(index, parent, titleField);
	var otherCellsListItems = otherFields.map(function (field) {
		var cellContent = (0, _utils.renderCell)(index, parent, field);
		var tooltip = typeof cellContent === 'string' ? cellContent : null;
		var label = (0, _utils.getLabel)(field);
		return _react2.default.createElement(
			'li',
			null,
			label && _react2.default.createElement(
				'span',
				{ className: _Large2.default['field-label'] },
				label,
				': '
			),
			_react2.default.createElement(
				'span',
				{ className: _Large2.default['field-value'], title: tooltip },
				cellContent
			)
		);
	});

	return _react2.default.createElement(
		'div',
		{
			className: _Large2.default['tc-list-large'],
			key: key,
			style: style
		},
		_react2.default.createElement(
			'div',
			{ className: (0, _classnames2.default)('tc-list-large-row', _Large2.default['inner-box']) },
			titleCell,
			_react2.default.createElement(
				'ul',
				{ className: _Large2.default.content },
				otherCellsListItems
			)
		)
	);
}

Large.displayName = 'VirtualizedList(List > Large)';
Large.propTypes = {
	index: _react.PropTypes.number,
	key: _react.PropTypes.string,
	parent: _react.PropTypes.arrayOf(_react.PropTypes.element),
	style: _react.PropTypes.object
};

exports.default = Large;